
class TData {
/*This class is to store the values of one example.*/
public:
	double time;
	double literals;
	unsigned int choice;
	unsigned int wchoice;
	unsigned int answer;
	unsigned int trueAss;
	unsigned int atoms;
	unsigned int rules;
	unsigned int sSpace;
	bool operator<(const TData tdat) const
	{
		return (time<tdat.time);
	}
	bool static lowerChoice(const TData tdat1,const TData tdat2)
	{
		return (tdat1.choice<tdat2.choice);
	}
	bool static lowerWChoice(const TData tdat1,const TData tdat2)
	{
		return (tdat1.wchoice<tdat2.wchoice);
	}
};

class TTupel{
public:
	unsigned int x,y;
	bool operator<(const TTupel tup) const
	{
		return (x<tup.x);
	}
};

class TDResult
{
/*This class is to store the evaluate results values of one testcase.*/
public:
	char name[100];//name of the testcase
	double literals;//literals parameter of the generator
	unsigned int atoms;//atoms parameter of the generator
	unsigned int rules;//rules parameter of the generator
	unsigned int examples;//examples in the testcase
	double avTime;//average time
	double avSearchSp;//average search space
	double avChoice;//average choice
	double avWChoice;//average wrong choices
	unsigned int posExamples;//positive examples
	double posAvTime;//average time of positive examples
	double posAvSearchSp;//average search space of positive examples
	double posAvChoice;//average choice of positive examples
	unsigned int negExamples;//negative examples
	double negAvTime;//average time of negative examples
	double negAvSearchSp;//average search space of negative examples
	double negAvChoice;//average choice of negative examples
	double minTime;//minimal time
	double maxTime[10];//maximal time of the classes with 10 per cent of examples
	//, which are the next better after maxTime[n-1](btw if n=0 minTime)
	unsigned int minSearchSp;//minimal search space
	unsigned int maxSearchSp;//maximal search space
	double clAvTime[10];//average time of the classes with 10 per cent of examples
	double timeSpread;//spread of the time values
	double searchSpSpread;//spread of the search space values
	double timeVarianz;//time varianz
	double choiceVarianz;//choice point varianze
	double wChoiceVarianz;//varianc of the wrong choicese
	double searchSpVarianz;//search space varianz
/*	double timeMean;//time mean (Streuung)
	double searchSpMean;//search space mean (Streuung)
*/	double averageAtoms;//average atoms of the testcase
	double averageRules;//average rules of the testcase
	double avCTQutient;//average choise/time qutient
	double cTQutientVarianz;//average choise/time qutient varianze
	double medianTime;//time median
	double medianChoice;//choice median
	double medianWChoice;//wrong choice median
	double minChoice;//minimal choices
	double maxChoice;//maximal choices
	double minWChoice;//minimal worng choices
	double maxWChoice;//maximal wrong choices
	double posAvWChoice;//positiv average wrong choices
	double negAvWChoice;//negativ average wrong choices
	double avWCTQutient;//average wrong choise/time qutient
	double wCTQutientVarianz;//average wrong choise/time qutient varianze
	double avDChoice;//average choice-wchoice value
	double dChoiceVarianz;//varianz choice-wchoice value

	double mNTimePTime;//(negativ time) - (positiv time)
	double dNTimePTime;//(negativ time)/(positiv time)
	double logDNTimePTime;//log(negativ time)/log(positiv time)
	double mNChoicePChoice;//(negativ choice points) - (positiv choice points)
	double dNChoicePChoice;//(negativ choice points)/(positiv choice points)
	double logDNChoicePChoice;//log(negativ choice points)/log(positiv choice points)
	double mNWChoicePWChoice;//(negativ wrong choices) - (positiv wrong choices)
	double dNWChoicePWChoice;//(negativ wrong choices)/(positiv wrong choices)
	double logDNWChoicePWChoice;//log(negativ wrong choices)/log(positiv wrong choices)

	unsigned int edges;
	unsigned int vertices;


	bool operator<(const TDResult tres) const
	/*the lower realtion for TDResult
	to order the TDResults, first coms the literals, then the atoms and then
	the rules
	pre: two TDResult
	post: true if first TDResult is lower than the secound, else false*/
	{
	return ((vertices<tres.vertices)||
		((vertices==tres.vertices)&&((edges<tres.edges))));
	}

	bool static lowerAtoms(const TDResult tres1,const TDResult tres2)
	{
		return (tres1.atoms<tres2.atoms);
	}

	bool static lowerRules(const TDResult tres1,const TDResult tres2)
	{
		return (tres1.rules<tres2.rules);
	}

	bool static lowerLiterals(const TDResult tres1,const TDResult tres2)
	{
		return (tres1.literals<tres2.literals);
	}
};

list<TData> readData(char* file)
/*This method reads the data of one testcase and store it to a list of TData
pre: the name of the file wher the data of the testcase is stored in the
	BMTool output form
post: the TData list with the readed values*/
{
list<TData> tmpDataL;
char c=' ';
unsigned int i;
char name[100];
TData dat;
dat.time=0.0;
dat.choice=0;
dat.wchoice=0;
dat.answer=0;
dat.trueAss=0;
dat.atoms=0;
dat.rules=0;
dat.literals=0.0;
char ls[100];

sprintf(ls,"ls %s",file);
int existsT=system(ls);//test if ther exists such file
if (existsT!=0){return tmpDataL;}

ifstream *stream=new ifstream(file);
if( stream!= NULL )
{
	//read first part till the first data set
	i=0;
	while (c!='|')
	{
		(*stream)>>c;
		if (!((c=='|')||(c==' '))) {name[i]=c;i++;}
	}
	name[i+1]=0;
	cout<<name<<endl<<flush;
	(*stream)>>c;
	while (c!='|'){(*stream)>>c;}
	while (c!='l'){(*stream)>>c;}
	//read line
	while (true)
	{
		c='a';
		//read till the first values of the data begin
		while (!((c=='|')||(c=='-'))){(*stream)>>c;}
		if (c=='-'){break;}
		(*stream)>>dat.time;
		(*stream)>>c;//read ';'
		(*stream)>>dat.choice;
		(*stream)>>c;//read ';'
		(*stream)>>dat.wchoice;
		(*stream)>>c;//read ';'
		(*stream)>>c;
		if(c=='1')//read if ther is a answer
		{
			dat.answer=1;
		}else{//"NV"
			dat.answer=0;
			(*stream)>>c;
		}
		(*stream)>>c;//read ';'
		//optional part, the next values are not nessesarry in ale testcases
		if ((c==';')||(c==','))
		{
			(*stream)>>dat.trueAss;
			(*stream)>>c;//read ';'
			if ((c==';')||(c==','))
			{
				(*stream)>>dat.atoms;
				(*stream)>>c;//read ';'
					if ((c==';')||(c==','))
					{
						(*stream)>>dat.rules;
						(*stream)>>c;//read ';'
					if ((c==';')||(c==','))
					{
						(*stream)>>dat.sSpace;
						(*stream)>>c;//read ';'
						if ((c==';')||(c==','))
						{
							(*stream)>>dat.literals;
							(*stream)>>c;//read ';'
		}}}}}
		while (c!='|'){(*stream)>>c;}

//		cout<<dat.time<<";"<<dat.choice<<";"<<dat.wchoice<<";"<<dat.answer;
//		cout<<";"<<dat.trueAss<<";"<<dat.atoms<<";"<<dat.rules<<endl;
		tmpDataL.insert(tmpDataL.end(),dat);
	}
	stream->close();
	delete stream;
}
else
	{printf( "Problem opening the file\n" );}
return tmpDataL;
}

TDResult evalueResult(char *file)
/*evaluates the results of the testcase in the file file
pre: the name of the file file wher testcase data ist stored, the number of
	atoms, rules and literals with wich the testcase was generated
post: the results of the testcase as a TDResult*/
{
//read data of testcase
list<TData> dataL;
dataL=readData(file);
TDResult result;
unsigned int i=0;
while ((file[i]!=0)||(i<100))
	{result.name[i]=file[i];i++;}
dataL.sort();
i=0;
//init values of the result
result.literals=0.0;
result.atoms=0;
result.rules=0;
result.examples=dataL.size();
//average time
result.avTime=0.0;
result.avChoice=0.0;
//average search space
result.avSearchSp=0.0;
//positive examples
result.posExamples=0;
//average time of positive examples
result.posAvTime=0.0;
result.posAvChoice=0.0;
result.posAvWChoice=0.0;
//rage search space of positive examples
result.posAvSearchSp=0.0;
//average time of negative examples
result.negAvTime=0.0;
result.negAvChoice=0.0;
result.negAvWChoice=0.0;
//average search space of negative examples
result.negAvSearchSp=0.0;
result.minChoice=(dataL.begin())->choice;//minimal choices
result.maxChoice=(dataL.begin())->choice;//maximal choices
result.minWChoice=(dataL.begin())->wchoice;//minimal worng choices
result.maxWChoice=(dataL.begin())->wchoice;//maximal wrong choices
result.minSearchSp=(dataL.begin())->trueAss;//minimal search space
result.maxSearchSp=(dataL.begin())->trueAss;//maximal search space
result.timeVarianz=0.0;//time varianz
result.choiceVarianz=0.0;
result.searchSpVarianz=0.0;//search space varianz
for (unsigned int a=0;a<10;a++)
	{result.clAvTime[a]=0;}
result.averageAtoms=0.0;
result.averageRules=0.0;
result.avCTQutient=0.0;
result.cTQutientVarianz=0.0;
result.avWCTQutient=0.0;
result.wCTQutientVarianz=0.0;
result.avWChoice=0.0;
result.wChoiceVarianz=0.0;

result.avDChoice=0.0;//average choice-wchoice value
result.dChoiceVarianz=0.0;//varianz choice-wchoice value


//evalue values of the testcase
list<TData>::iterator itr;
for (itr=dataL.begin();itr!=dataL.end();itr++)
{
	result.avTime+=itr->time;
	result.avSearchSp+=(double)(itr->trueAss);
	result.avChoice+=(double)(itr->choice);
	result.avWChoice+=(double)(itr->wchoice);
	result.avDChoice+=(double)((itr->choice)-(itr->wchoice));
	result.averageAtoms+=itr->atoms;
	result.averageRules+=itr->rules;
	result.literals+=itr->literals;
	i++;
	if ((((i*10)/dataL.size())*dataL.size())==(i*10))
		{result.maxTime[((i-1)*10)/dataL.size()]=itr->time;}
	result.clAvTime[(i*10)/dataL.size()]+=itr->time;
	if ((itr->answer)>0)
	{	result.posExamples++;
		result.posAvTime+=itr->time;
		result.posAvSearchSp+=(double)(itr->trueAss);
		result.posAvChoice+=(double)(itr->choice);
		result.posAvWChoice+=(double)(itr->wchoice);
	}else{
		result.negAvTime+=itr->time;
		result.negAvSearchSp+=(double)(itr->trueAss);
		result.negAvChoice+=(double)(itr->choice);
		result.negAvWChoice+=(double)(itr->wchoice);
	}
	if (result.minChoice>(itr->choice)) {result.minChoice=(itr->choice);}
	if (result.maxChoice<(itr->choice)) {result.maxChoice=(itr->choice);}
	if (result.minWChoice>(itr->wchoice)) {result.minWChoice=(itr->wchoice);}
	if (result.maxWChoice<(itr->wchoice)) {result.maxWChoice=(itr->wchoice);}
	if (result.minSearchSp>(itr->trueAss)) {result.minSearchSp=(itr->trueAss);}
	if (result.maxSearchSp<(itr->trueAss)) {result.maxSearchSp=(itr->trueAss);}
	result.timeVarianz+=(itr->time)*(itr->time);
	result.choiceVarianz+=(double)(itr->choice)*(double)(itr->choice);
	result.wChoiceVarianz+=(double)(itr->wchoice)*(double)(itr->wchoice);
	result.dChoiceVarianz+=(double)((itr->choice)-(itr->wchoice))*(double)((itr->choice)-(itr->wchoice));
	result.searchSpVarianz+=(double)(itr->trueAss)*(double)(itr->trueAss);
	if ((itr->time)>0)
	{
		result.avCTQutient+=((double)(itr->choice))/(itr->time);
		result.cTQutientVarianz+=(((double)(itr->choice))/(itr->time))*(((double)(itr->choice))/(itr->time));
		result.avWCTQutient+=((double)(itr->wchoice))/(itr->time);
		result.wCTQutientVarianz+=(((double)(itr->wchoice))/(itr->time))*(((double)(itr->wchoice))/(itr->time));
	}
	if(dataL.size()/2==i){result.medianTime=itr->time;}
}
result.avSearchSp=result.avSearchSp/dataL.size();
result.avTime=result.avTime/dataL.size();
result.avChoice=result.avChoice/dataL.size();
result.avWChoice=result.avWChoice/dataL.size();
result.avDChoice=result.avDChoice/dataL.size();
result.avCTQutient=result.avCTQutient/dataL.size();
result.avWCTQutient=result.avWCTQutient/dataL.size();

result.posAvTime=result.posAvTime/result.posExamples;
result.posAvChoice=result.posAvChoice/result.posExamples;
result.posAvSearchSp=result.posAvSearchSp/result.posExamples;
result.posAvWChoice=result.posAvWChoice/result.posExamples;

result.negExamples=dataL.size()-result.posExamples;//negative examples

result.negAvTime=result.negAvTime/result.negExamples;
result.negAvChoice=result.negAvChoice/result.negExamples;
result.negAvSearchSp=result.negAvSearchSp/result.negExamples;
result.negAvWChoice=result.negAvWChoice/result.negExamples;

result.averageAtoms=result.averageAtoms/dataL.size();
result.averageRules=result.averageRules/dataL.size();
result.literals=result.literals/dataL.size();
result.minTime=(dataL.begin())->time;//minimal time
result.timeSpread=result.maxTime[9]-result.minTime;
result.searchSpSpread=result.maxSearchSp-result.minSearchSp;
result.timeVarianz=(result.timeVarianz)/dataL.size()-(result.avTime)*(result.avTime);
result.choiceVarianz=(result.choiceVarianz)/dataL.size()-(result.avChoice)*(result.avChoice);
result.searchSpVarianz=(result.searchSpVarianz)/dataL.size()-(result.avSearchSp)*(result.avSearchSp);
result.cTQutientVarianz=(result.cTQutientVarianz)/dataL.size()-(result.avCTQutient)*(result.avCTQutient);
result.wCTQutientVarianz=(result.wCTQutientVarianz)/dataL.size()-(result.avWCTQutient)*(result.avWCTQutient);
result.wChoiceVarianz=(result.wChoiceVarianz)/dataL.size()-(result.avWChoice)*(result.avWChoice);
result.dChoiceVarianz=(result.dChoiceVarianz)/dataL.size()-(result.avDChoice)*(result.avDChoice);
for (unsigned int a=0;a<10;a++)
	{result.clAvTime[a]=(result.clAvTime[a]*10.0)/dataL.size();}

//correct divede 0 values
if (dataL.size()==0){result.avSearchSp=0.0;result.avTime=0.0;result.avChoice=0.0;result.avCTQutient=0.0;
	result.averageAtoms=0.0;result.averageRules=0.0;result.timeVarianz=0.0;result.choiceVarianz=0.0;
	result.searchSpVarianz=0.0;result.cTQutientVarianz=0.0;result.avWChoice=0.0;result.wChoiceVarianz=0.0;
	result.avDChoice=0.0;result.literals=0.0;
	for (unsigned int a=0;a<10;a++)
		{result.clAvTime[a]=0.0;}
	}
if (result.posExamples==0){result.posAvTime=0.0;result.posAvChoice=0.0;result.posAvSearchSp=0.0;result.posAvWChoice=0.0;}
if (result.negExamples==0){result.negAvTime=0.0;result.negAvChoice=0.0;result.negAvSearchSp=0.0;result.negAvWChoice=0.0;}

dataL.sort(&TData::lowerChoice);
itr=dataL.begin();
for (i=0;i<=(dataL.size()/2);i++)
	{itr++;}
result.medianChoice=(itr->choice);
dataL.sort(&TData::lowerWChoice);
itr=dataL.begin();
for (i=0;i<=(dataL.size()/2);i++)
	{itr++;}
result.medianWChoice=(itr->wchoice);

result.mNTimePTime=result.negAvTime-result.posAvTime;//(negativ time) - (positiv time)
result.dNTimePTime=result.negAvTime/result.posAvTime;//(negativ time)/(positiv time)
if ((result.negAvTime>0.0)&&(result.posAvTime>0.0))//log(negativ time)/log(positiv time)
	{result.logDNTimePTime=log(result.negAvTime)/log(result.posAvTime);}
else{result.logDNTimePTime=0.0;}
result.mNChoicePChoice=result.negAvChoice-result.posAvChoice;//(negativ choice point) - (positiv choice points)
result.dNChoicePChoice=result.negAvChoice/result.posAvChoice;//(negativ choice point)/(positiv choice points)
if ((result.negAvChoice>0.0)&&(result.posAvChoice>0.0))//log(negativ choice point)/log(positiv choice point)
	{result.logDNChoicePChoice=log(result.negAvChoice)/log(result.posAvChoice);}
else{result.logDNChoicePChoice=0.0;}
result.mNWChoicePWChoice=result.negAvWChoice-result.posAvWChoice;//(negativ wrong choices) - (positiv wrong choices)
result.dNWChoicePWChoice=result.negAvWChoice/result.posAvWChoice;//(negativ wrong choices)/(positiv wrong choices)
if ((result.negAvWChoice>0.0)&&(result.posAvWChoice>0.0))//log(negativ wrong choices)/log(positiv wrong choices)
	{result.logDNWChoicePWChoice=log(result.negAvWChoice)/log(result.posAvWChoice);}
else{result.logDNWChoicePWChoice=0.0;}


return result;
}

void writeHead(ofstream *stream)
/*writes the head of the result tabel in a excel readebel form
colums are seperated with ";"
pre: the stream to write the head to
post: the head of the table in the stream*/
{
(*stream)<<"rules/atoms ;name ;literals ;atoms ;rules ;examples ;average time ;average choices";
(*stream)<<" ;average wrong choice ;average search space";
(*stream)<<" ;time median ;choice median ;wrong choice median";
(*stream)<<" ;positiv examples ;positiv average time ;positiv average choices";
(*stream)<<" ;positiv average wrong choice ;positiv average search space";
(*stream)<<" ;negativ examples ;negativ average time ;negativ average choices";
(*stream)<<" ;negativ average wrong choice ;negative average search space";
(*stream)<<" ;min Time";
for (unsigned int i=0;i<10;i++){(*stream)<<" ;max time "<<i;}
for (unsigned int i=0;i<10;i++){(*stream)<<" ;class av. time "<<i;}
(*stream)<<" ;minimal choice ; maximal choice ;minimal wrong choice ; maximal wrong choice";
(*stream)<<" ;minimal search space ;maximal search space ;time spread ;search space spread";
(*stream)<<" ;time varianz ;choice varianz ;wrong choice varianz ;search space varianz ;average atoms ;average rules";
(*stream)<<" ;average choice point time qutient ;choice point time qutient varianz";
(*stream)<<" ;average wrong choice time qutient ;wrong choice time qutient varianz";
(*stream)<<" ;average (choice-(wrong choice)) ;(choice-(wrong choice)) varianz";
(*stream)<<" ;(negativ time) - (positiv time) ;(negativ time)/(positiv time) ;log(negativ time)/log(positiv time)";
(*stream)<<" ;(negativ choice point) - (positiv choice points) ; (negativ choice point)/(positiv choice points)";
(*stream)<<" ;log(negativ choice point)/log(positiv choice points)";
(*stream)<<" ;(negativ wrong choices) - (positiv wrong choices) ; (negativ wrong choices)/(positiv wrong choices)";
(*stream)<<" ;log(negativ wrong choices)/log(positiv wrong choices); vertices; edges; edges/(vertices*log(vertices))"<<endl;
}

void writeResult(ofstream *stream,TDResult result)
/*writes one given result to the stream in a excel readebel form
colums are seperated with ";"
pre: the stream to print the result data to and the result to print
post: the result in the stream*/
{
(*stream)<<double(result.averageRules)/double(result.averageAtoms)<<" ; "<<result.name<<" ; "<<result.literals<<" ; "<<result.atoms;
(*stream)<<" ; "<<result.rules<<" ; "<<result.examples;
(*stream)<<" ; "<<result.avTime<<" ; "<<result.avChoice<<" ; "<<result.avWChoice<<" ;"<<result.avSearchSp;
(*stream)<<" ; "<<result.medianTime<<" ; "<<result.medianChoice<<" ; "<<result.medianWChoice;
(*stream)<<" ; "<<result.posExamples<<" ; "<<result.posAvTime;
(*stream)<<" ; "<<result.posAvChoice<<" ; "<<result.posAvWChoice<<" ; "<<result.posAvSearchSp;
(*stream)<<" ; "<<result.negExamples<<" ; "<<result.negAvTime;
(*stream)<<" ; "<<result.negAvChoice<<" ; "<<result.negAvWChoice<<" ; "<<result.negAvSearchSp;
(*stream)<<" ; "<<result.minTime;
for (unsigned int i=0;i<10;i++){(*stream)<<" ;"<<result.maxTime[i];}
for (unsigned int i=0;i<10;i++){(*stream)<<" ;"<<result.clAvTime[i];}
(*stream)<<" ; "<<result.minChoice<<" ; "<<result.maxChoice<<" ; "<<result.minWChoice<<" ; "<<result.maxWChoice;
(*stream)<<" ; "<<result.minSearchSp<<" ; "<<result.maxSearchSp;
(*stream)<<" ; "<<result.timeSpread<<" ; "<<result.searchSpSpread;
(*stream)<<" ; "<<result.timeVarianz<<" ;"<<result.choiceVarianz;
(*stream)<<" ;"<<result.wChoiceVarianz<<" ; "<<result.searchSpVarianz;
(*stream)<<" ; "<< result.averageAtoms<<" ; "<<result.averageRules;
(*stream)<<" ; "<< result.avCTQutient<<" ; "<< result.cTQutientVarianz;
(*stream)<<" ; "<< result.avWCTQutient<<" ; "<< result.wCTQutientVarianz;
(*stream)<<" ; "<< result.avDChoice<<" ; "<< result.dChoiceVarianz;
(*stream)<<" ; "<< result.mNTimePTime<<" ; "<< result.dNTimePTime<<" ; "<< result.logDNTimePTime;
(*stream)<<" ; "<< result.mNChoicePChoice<<" ; "<< result.dNChoicePChoice<<" ; "<< result.logDNChoicePChoice;
(*stream)<<" ; "<< result.mNWChoicePWChoice<<" ; "<< result.dNWChoicePWChoice<<" ; "<< result.logDNWChoicePWChoice;
(*stream)<<" ; "<<result.vertices<<" ; "<<result.edges;
(*stream)<<" ; "<<double(result.edges)/(double(result.vertices)*log(double(result.vertices)))<<endl;
}

void writeResultBl(ofstream *stream,TDResult result)
/*writes one given result to the stream in a excel readebel form
colums are seperated with " "(blank)
pre: the stream to print the result data to and the result to print
post: the result in the stream*/
{
(*stream)<<double(result.averageRules)/double(result.averageAtoms)<<" "<<result.name<<" "<<result.literals<<" "<<result.atoms;
(*stream)<<" "<<result.rules<<" "<<result.examples;
(*stream)<<" "<<result.avTime<<" "<<result.avChoice<<" "<<result.avWChoice<<" "<<result.avSearchSp;
(*stream)<<" "<<result.medianTime<<" "<<result.medianChoice<<" "<<result.medianWChoice;
(*stream)<<" "<<result.posExamples<<" "<<result.posAvTime;
(*stream)<<" "<<result.posAvChoice<<" "<<result.posAvWChoice<<" "<<result.posAvSearchSp;
(*stream)<<" "<<result.negExamples<<" "<<result.negAvTime;
(*stream)<<" "<<result.negAvChoice<<" "<<result.negAvWChoice<<" "<<result.negAvSearchSp;
(*stream)<<" "<<result.minTime;
for (unsigned int i=0;i<10;i++){(*stream)<<" "<<result.maxTime[i];}
for (unsigned int i=0;i<10;i++){(*stream)<<" "<<result.clAvTime[i];}
(*stream)<<" "<<result.minChoice<<" "<<result.maxChoice<<" "<<result.minWChoice<<" "<<result.maxWChoice;
(*stream)<<" "<<result.minSearchSp<<" "<<result.maxSearchSp;
(*stream)<<" "<<result.timeSpread<<" "<<result.searchSpSpread;
(*stream)<<" "<<result.timeVarianz<<" "<<result.choiceVarianz;
(*stream)<<" "<<result.wChoiceVarianz<<" "<<result.searchSpVarianz;
(*stream)<<" "<< result.averageAtoms<<" "<<result.averageRules;
(*stream)<<" "<< result.avCTQutient<<" "<< result.cTQutientVarianz;
(*stream)<<" "<< result.avWCTQutient<<" "<< result.wCTQutientVarianz;
(*stream)<<" "<< result.avDChoice<<" "<< result.dChoiceVarianz;
(*stream)<<" "<< result.mNTimePTime<<" "<< result.dNTimePTime<<" "<< result.logDNTimePTime;
(*stream)<<" "<< result.mNChoicePChoice<<" "<< result.dNChoicePChoice<<" "<< result.logDNChoicePChoice;
(*stream)<<" "<< result.mNWChoicePWChoice<<" "<< result.dNWChoicePWChoice<<" "<< result.logDNWChoicePWChoice;
(*stream)<<" "<<result.vertices<<" "<<result.edges;
(*stream)<<" "<<double(result.edges)/(double(result.vertices)*log(double(result.vertices)));
(*stream)<<" "<<double(result.edges)/(double(result.vertices))<<endl;
}

void plotData(char* baseName,unsigned int wich,char* wichName,char* filePName,int titleNumber,char* titleString)
/*prints the graphs to the data in the file "./gnuplotTmp.txt" (stored
results with blanks betwean), the graphs are flat (2 dimensional)
most graphs are printed in normal and log scale
the graphs are generated with gnuplot
pre: the base name baseName of the folder and file to store the graphs to,
	the number wich of the colum wher the x values of the graph stand,
	the name wichName of the x values (e.g. "rules"), the begin of name
	filePName the graph file to store the graph to, the titelNumber and
	titelString to write in the titel (eg. titelNumber=55 ;titelString="atoms"
	then a part of the title is "... 55 atoms ...") and the numbers of
	literals in the data (how much literals the testcases have)
post: the graphs of the data*/
{
ofstream *stream=new ofstream("./gnuplotTmp.txt");
//output time
(*stream)<<"set terminal postscript"<<endl;
(*stream)<<"set nokey"<<endl;
//(*stream)<<"set size 1, 1"<<endl;
(*stream)<<"set format xy \"%g\""<<endl;
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average time for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set xlabel \""<<wichName<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":7 with linespoints "<<endl;
//output examples
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_e_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"examples n\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":6 with linespoints "<<endl;
//output choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_c_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average choice for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":8 with linespoints "<<endl;
//output wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average wrong choices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 with linespoints "<<endl;
//output choice-wchoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_dc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average (choice-(wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":63 with linespoints "<<endl;
//output median time
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_mt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"time median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":11 with linespoints "<<endl;
//output median choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_mc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"choice point median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":12 with linespoints "<<endl;
//output median wrong choices
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_mwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"wrong choices median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":13 with linespoints "<<endl;
//output minimum time
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_mint_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum time for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":24 with linespoints "<<endl;
//output minimum choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_minc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum choice points for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":45 with linespoints "<<endl;
//output maximum choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_maxc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximum choice points for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":46 with linespoints "<<endl;
//output minimum wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_minwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum wrong choices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":47 with linespoints "<<endl;
//output maximum wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_maxc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximum wrong choice for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":48 with linespoints "<<endl;
//output atoms
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_at_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average atoms for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"atoms A\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":57 with linespoints "<<endl;
//output rules
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_rl_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average rules for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"rules R\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":58 with linespoints "<<endl;
//output search space
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average search space (ss) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 with linespoints "<<endl;
//output time spread
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_sp_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"time spread for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":51 with linespoints "<<endl;
//output ss spread
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_sp_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"search space spread for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":52 with linespoints "<<endl;
//output time varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"time varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":53 with linespoints "<<endl;
//output choice varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_c_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"choice points varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":54 with linespoints "<<endl;
//output choice-wchoice varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_dc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"((choice points)-(wrong choice)) varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":64 with linespoints "<<endl;
//output search space varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"search space varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":56 with linespoints "<<endl;
//output choice/time quotient
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_CdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"choice points time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":59 with linespoints "<<endl;
//output choice/time quotient variance
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_CdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"varianz of choice points time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":60 with linespoints "<<endl;
//output wchoice/time quotient
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_WCdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"wrong choices time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":61 with linespoints "<<endl;
//output wchoice/time quotient variance
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_WCdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"varianz of wrong choices time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":62 with linespoints "<<endl;
//output wchoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average wrong choice for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 with linespoints "<<endl;
//output wchoice varianc
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_var_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"wrong choice varianc for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice varianc\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":55 with linespoints "<<endl;
//output mNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_m_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ time) - (positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":65 with linespoints "<<endl;
//output dNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ time)/(positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":66 with linespoints "<<endl;
//output logDNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_log_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ time)/log(positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":67 with linespoints "<<endl;
//output mNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_m_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ choice points)-(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":68 with linespoints "<<endl;
//output dNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ choice points)/(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":69 with linespoints "<<endl;
//output dNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_log_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ choice points)/log(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":70 with linespoints "<<endl;
//output mNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_m_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ wrong choices)-(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":71 with linespoints "<<endl;
//output dNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ wrong choices)/(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":72 with linespoints "<<endl;
//output dNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_d_log_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ wrong choices)/log(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":73 with linespoints "<<endl;
//output vertices
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_v_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"vertices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"vertices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":74 with linespoints "<<endl;
//output edges
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_ed_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"edges for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"edges\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":75 with linespoints "<<endl;
//output literals
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_l_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"literals for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"literals\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":3 with linespoints "<<endl;

//key section
//output examples pos neg
(*stream)<<"set key"<<endl;
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_epn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average examples positiv, negative and all for testcases with "<<titleNumber<<" "<<titleString<<" \""<<endl;
(*stream)<<"set ylabel \"examples n\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":6 title \"all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":14 title \"positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":19 title \"negativ examles\" with linespoints "<<endl;
//output time pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_tpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average time for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":7 title \"time all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":15 title \"time positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":20 title \"time negativ examles\" with linespoints "<<endl;
//output choice pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_cpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average choice points for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":8 title \"choice all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":16 title \"choice positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":21 title \"choice negativ examles\" with linespoints "<<endl;
//output wrong choice pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_wcpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average wrong choices for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 title \"wrong choices all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":17 title \"wrong choices positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":22 title \"wrong choices negativ examles\" with linespoints "<<endl;
//output search space pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_sspn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average search space for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 title \"search space all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":18 title \"search space positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":23 title \"search space negativ examles\" with linespoints "<<endl;
//output 10 maximal time classes
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_mtc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximal time of 10 time classes for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":24 title \"minimal time\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":25 title \"maximal time in class 1\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":26 title \"maximal time in class 2\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":27 title \"maximal time in class 3\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":28 title \"maximal time in class 4\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":29 title \"maximal time in class 5\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":30 title \"maximal time in class 6\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":31 title \"maximal time in class 7\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":32 title \"maximal time in class 8\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":33 title \"maximal time in class 9\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":34 title \"maximal time in class 10\" with linespoints "<<endl;
//output 10 time classes
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_tc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average time of 10 time classes for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":35 title \"time in class 1\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":36 title \"time in class 2\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":37 title \"time in class 3\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":38 title \"time in class 4\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":39 title \"time in class 5\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":40 title \"time in class 6\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":41 title \"time in class 7\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":42 title \"time in class 8\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":43 title \"time in class 9\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":44 title \"time in class 10\" with linespoints "<<endl;
//output search space max min
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_ssmm_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average, minimal and maximal search space for testcases with "<<titleNumber<<" "<<titleString<<" \""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 title \"average search space\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":49 title \"minimal search space\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":50 title \"maximal search space\" with linespoints "<<endl;


//log part
//output log time
(*stream)<<"set logscale y"<<endl;
(*stream)<<"set nokey"<<endl;
(*stream)<<"set title \"average log time for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":7 with linespoints "<<endl;
//output log choice
(*stream)<<"set title \"average log choice points for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_c_"<<baseName<<".ps\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":8 with linespoints "<<endl;
//output wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log wrong choices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 with linespoints "<<endl;
//output median time
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_mt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log time median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":11 with linespoints "<<endl;
//output median choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_mc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log choice points median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":12 with linespoints "<<endl;
//output median wrong choices
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_mwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log wrong choices median for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":13 with linespoints "<<endl;
//output minimum time
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_mint_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum log time for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":24 with linespoints "<<endl;
//output minimum choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_minc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum log choice points for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":45 with linespoints "<<endl;
//output maximum choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_maxc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximum log choice points for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":46 with linespoints "<<endl;
//output minimum wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_minwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"minimum log wrong choices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":47 with linespoints "<<endl;
//output maximum wrong choice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_maxc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximum log wrong choice for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":48 with linespoints "<<endl;
//output search space
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log search space (ss) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 with linespoints "<<endl;
//output time spread
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_sp_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log time spread for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":51 with linespoints "<<endl;
//output ss spread
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_sp_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log search space spread for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":52 with linespoints "<<endl;
//output time varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_t_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log time varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":53 with linespoints "<<endl;
//output choice varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_c_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log choice points varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":54 with linespoints "<<endl;
//output search space varianz
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_ss_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log search space varianz for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":56 with linespoints "<<endl;
//output choice/time quotient
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_CdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log choice points time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":59 with linespoints "<<endl;
//output choice/time quotient variance
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_CdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log varianz of choice points time quotient for testcases with "<<titleNumber<<" "<<titleString<<" \""<<endl;
(*stream)<<"set ylabel \"choice points/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":60 with linespoints "<<endl;
//output wchoice/time quotient
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_WCdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log wrong choices time quotient for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":61 with linespoints "<<endl;
//output wchoice/time quotient variance
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_WCdT_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log varianz of wrong choices time quotient for testcases with "<<titleNumber<<" "<<titleString<<" \""<<endl;
(*stream)<<"set ylabel \"wrong choice/time 1/s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":62 with linespoints "<<endl;
//output wchoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log wrong choice for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 with linespoints "<<endl;
//output wchoice varianc
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_var_wc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log wrong choice varianc for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choice varianc\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":55 with linespoints "<<endl;
//output mNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_m_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ time) - (positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":65 with linespoints "<<endl;
//output dNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ time)/(positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":66 with linespoints "<<endl;
//output logDNTimePTime
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_log_ntpt_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ time)/log(positiv time) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":67 with linespoints "<<endl;
//output mNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_m_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ choice points)-(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":68 with linespoints "<<endl;
//output dNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ choice points)/(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":69 with linespoints "<<endl;
//output dNChoicePChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_log_ncpc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ choice points)/log(positiv choice points) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":70 with linespoints "<<endl;
//output mNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_m_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ wrong choices)-(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":71 with linespoints "<<endl;
//output dNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"(negativ wrong choices)/(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":72 with linespoints "<<endl;
//output dNWChoicePWChoice
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_d_log_nwcpwc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"log(negativ wrong choices)/log(positiv wrong choices) for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"Faktor\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":73 with linespoints "<<endl;
//output vertices
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_v_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"vertices for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"vertices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":74 with linespoints "<<endl;
//output Edges
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_ed_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"edges for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"edges\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":75 with linespoints "<<endl;


//key section
//output time pos neg
(*stream)<<"set key"<<endl;
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_tpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log time for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":7 title \"time all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":15 title \"time positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":20 title \"time negativ examles\" with linespoints "<<endl;
//output choice pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_cpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log choice points for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"choice points\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":8 title \"choice all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":16 title \"choice positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":21 title \"choice negativ examles\" with linespoints "<<endl;
//output wrong choice pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_wcpn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log wrong choices for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"wrong choices\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":9 title \"wrong choices all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":17 title \"wrong choices positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":22 title \"wrong choices negativ examles\" with linespoints "<<endl;
//output search space pos neg
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_sspn_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log search space for positiv, negative and all examples for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 title \"search space all examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":18 title \"search space positiv examles\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":23 title \"search space negativ examles\" with linespoints "<<endl;
//output 10 maximal time classes
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_mtc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"maximal log time of 10 time classes for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":24 title \"minimal time\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":25 title \"maximal time in class 1\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":26 title \"maximal time in class 2\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":27 title \"maximal time in class 3\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":28 title \"maximal time in class 4\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":29 title \"maximal time in class 5\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":30 title \"maximal time in class 6\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":31 title \"maximal time in class 7\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":32 title \"maximal time in class 8\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":33 title \"maximal time in class 9\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":34 title \"maximal time in class 10\" with linespoints "<<endl;
//output 10 time classes
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_tc_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average log time of 10 time classes for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"time s\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":35 title \"time in class 1\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":36 title \"time in class 2\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":37 title \"time in class 3\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":38 title \"time in class 4\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":39 title \"time in class 5\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":40 title \"time in class 6\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":41 title \"time in class 7\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":42 title \"time in class 8\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":43 title \"time in class 9\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":44 title \"time in class 10\" with linespoints "<<endl;
//output search space max min
(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/"<<filePName<<"_log_ssmm_"<<baseName<<".ps\""<<endl;
(*stream)<<"set title \"average, minimal and maximal log search space for testcases with "<<titleNumber<<" "<<titleString<<"\""<<endl;
(*stream)<<"set ylabel \"search space ss\""<<endl;
(*stream)<<"plot \"./tmpG1.txt\" using "<<wich<<":10 title \"average search space\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":49 title \"minimal search space\" with linespoints ";
(*stream)<<",\"./tmpG1.txt\" using "<<wich<<":50 title \"maximal search space\" with linespoints "<<endl;


system("gnuplot ./gnuplotTmp.txt");
stream->close();
delete stream;
}

void plotData3D(char* baseName)
/*prints the graphs to the data in the file "./gnuplotTmp.txt" (stored
results with blanks betwean), the graphs are 3 dimensional
most graphs are printed in normal and log scale
the graphs are generated with gnuplot
pre: the base name baseName of the folder and file to store the graphs to
	and the numbers of literals in the data (how much literals the testcases have)
post: the graphs of the data*/
{
ofstream *stream=new ofstream("./gnuplotTmp.txt");
if( stream!= NULL )
{
	(*stream)<<"set terminal postscript"<<endl;
//	(*stream)<<"set size 1, 1"<<endl;
	(*stream)<<"set format xy \"%g\""<<endl;

	//output examples bars
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/e_poi_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples for testcases\""<<endl;
	(*stream)<<"set xlabel \"vertices\""<<endl;
	(*stream)<<"set ylabel \"edges\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:6 with points"<<endl;


	(*stream)<<"set key"<<endl;
	//output time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:7 with points"<<endl;
	//output examples
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/e_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:6 with points"<<endl;
	//output choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/c_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:8 with points"<<endl;
	//output choice-wchoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/dc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average ((choice points)-(wrong coice)) for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:63 with points"<<endl;
	//output median time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/mt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time median for testcases\""<<endl;
	(*stream)<<"set zlabel \"time\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:11 with points"<<endl;
	//output median choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/mc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"choice points median for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:12 with points"<<endl;
	//output median wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/mwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong choices median for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:13"<<endl;
	//output minimum time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/mint_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum time for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:24 with points"<<endl;
	//output minimum choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/minc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:45 with points"<<endl;
	//output maximum choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/maxc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximum choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:46 with points"<<endl;
	//output minimum wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/minc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:47 with points"<<endl;
	//output maximum wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/maxc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximum wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:48 with points"<<endl;
	//output atoms
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/at_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average atoms for testcases\""<<endl;
	(*stream)<<"set zlabel \"atoms A\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:57 with points"<<endl;
	//output rules
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/rl_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average rules for testcases\""<<endl;
	(*stream)<<"set zlabel \"rules R\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:58 with points"<<endl;
	//output search space
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average search space (ss) for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:10 with points"<<endl;
	//output time spread
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/sp_t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time spread for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:51 with points"<<endl;
	//output ss spread
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/sp_ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"search space spread for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:52 with points"<<endl;
	//output time varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:53 with points"<<endl;
	//output choice varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_c_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"choice points varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:54 with points"<<endl;
	//output choice-wchoice varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_dc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"((choice points)-(wrong choice)) varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:64 with points"<<endl;
	//output search space varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"search space varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:56 with points"<<endl;
	//output choice/time quotient
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/CdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"coice points time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:59 with points"<<endl;
	//output choice/time quotient variance
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_CdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"varianz of coice points time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"coice points/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:60 with points"<<endl;
	//output wrong choice/time quotient
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/WCdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong coices time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:61 with points"<<endl;
	//output choice/time quotient variance
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_WCdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"varianz of wrong coices time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong coices/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:62 with points"<<endl;
	//output wchoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/wc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:9 with points"<<endl;
	//output wchoice varianc
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/var_wc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong choices variance for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:55 with points"<<endl;
	//output mNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/m_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ time) - (positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:65 with points"<<endl;
	//output dNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ time)/(positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:66 with points"<<endl;
	//output logDNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_log_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ time)/log(positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:67 with points"<<endl;
	//output mNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/m_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ choice points)-(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:68 with points"<<endl;
	//output dNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ choice points)/(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:69 with points"<<endl;
	//output dNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_log_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ choice points)/log(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:70 with points"<<endl;
	//output mNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/m_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ wrong choices)-(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:71 with points"<<endl;
	//output dNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ wrong choices)/(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:72 with points"<<endl;
	//output dNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/d_log_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ wrong choices)/log(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:73 with points"<<endl;
	//output vertices
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/v_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"vertices for testcases\""<<endl;
	(*stream)<<"set zlabel \"vertices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:74 with points"<<endl;
	//output edges
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/ed_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"edges for testcases\""<<endl;
	(*stream)<<"set zlabel \"edges\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:75 with points"<<endl;
	//output literals
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/l_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average literals for testcases\""<<endl;
	(*stream)<<"set zlabel \"literals\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:3 with points"<<endl;
	//output RdA
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/RdA_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average R/A qutient for testcases\""<<endl;
	(*stream)<<"set zlabel \"Rules/Atoms R/A\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:1 with points"<<endl;

	//key section
	//output examples pos neg
//	(*stream)<<"set key"<<endl;
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/epn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples positiv, negative and all for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:14 title \"positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:19 title \"negativ examles\" with points"<<endl;
	//output examples pos
//	(*stream)<<"set key"<<endl;
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/ep_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples positiv and all for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:14 title \"positiv examles\" with points"<<endl;
	//output time pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/tpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:15 title \"time positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:20 title \"time negativ examles\" with points"<<endl;
	//output choice pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/cpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average choice points for positiv, negative and all examples for testcases \""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:16 title \"choice positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:21 title \"choice negativ examles\" with points"<<endl;
	//output wrong choice pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/wcpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average wrong choices for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:17 title \"wrong choice positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:22 title \"wrong choice negativ examles\" with points"<<endl;
	//output search space pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/sspn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average search space for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:18 title \"search space positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:23 title \"search space negativ examles\" with points"<<endl;
	//output 10 maximal time classes
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/mtc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximal time of 10 time classes for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:24 title \"minimal time\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:25 title \"maximal time in class 1\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:26 title \"maximal time in class 2\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:27 title \"maximal time in class 3\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:28 title \"maximal time in class 4\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:29 title \"maximal time in class 5\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:30 title \"maximal time in class 6\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:31 title \"maximal time in class 7\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:32 title \"maximal time in class 8\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:33 title \"maximal time in class 9\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:34 title \"maximal time in class 10\" with points"<<endl;
	//output 10 time classes
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/tc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time of 10 time classes for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:35 title \"time in class 1\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:36 title \"time in class 2\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:37 title \"time in class 3\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:38 title \"time in class 4\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:39 title \"time in class 5\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:40 title \"time in class 6\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:41 title \"time in class 7\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:42 title \"time in class 8\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:43 title \"time in class 9\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:44 title \"time in class 10\" with points"<<endl;
	//output search space max min
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/ssmm_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average, minimal and maximal search space for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 74:75:10 title \"average search space\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:49 title \"minimal search space\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 74:75:50 title \"maximal search space\" with points"<<endl;

	system("gnuplot ./gnuplotTmp.txt");
	stream->close();
	delete stream;
}else
	{printf( "Problem opening the file\n" );}
}

void plotData3DAR(char* baseName)
/*prints the graphs to the data in the file "./gnuplotTmp.txt" (stored
results with blanks betwean), the graphs are 3 dimensional
most graphs are printed in normal and log scale
the graphs are generated with gnuplot
pre: the base name baseName of the folder and file to store the graphs to
	and the numbers of literals in the data (how much literals the testcases have)
post: the graphs of the data*/
{
ofstream *stream=new ofstream("./gnuplotTmp.txt");
if( stream!= NULL )
{
	(*stream)<<"set terminal postscript"<<endl;
//	(*stream)<<"set size 1, 1"<<endl;
	(*stream)<<"set format xy \"%g\""<<endl;

	//output examples bars
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_e_poi_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples for testcases\""<<endl;
	(*stream)<<"set xlabel \"atoms\""<<endl;
	(*stream)<<"set ylabel \"rules\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:6 with points"<<endl;


	(*stream)<<"set key"<<endl;
	//output time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:7 with points"<<endl;
	//output examples
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_e_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:6 with points"<<endl;
	//output choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_c_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:8 with points"<<endl;
	//output choice-wchoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_dc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average ((choice points)-(wrong coice)) for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:63 with points"<<endl;
	//output median time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_mt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time median for testcases\""<<endl;
	(*stream)<<"set zlabel \"time\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:11 with points"<<endl;
	//output median choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_mc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"choice points median for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:12 with points"<<endl;
	//output median wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_mwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong choices median for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:13"<<endl;
	//output minimum time
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_mint_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum time for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:24 with points"<<endl;
	//output minimum choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_minc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:45 with points"<<endl;
	//output maximum choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_maxc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximum choice points for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:46 with points"<<endl;
	//output minimum wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_minc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"minimum wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:47 with points"<<endl;
	//output maximum wrong choice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_maxc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximum wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:48 with points"<<endl;
	//output atoms
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_at_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average atoms for testcases\""<<endl;
	(*stream)<<"set zlabel \"atoms A\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:57 with points"<<endl;
	//output rules
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_rl_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average rules for testcases\""<<endl;
	(*stream)<<"set zlabel \"rules R\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:58 with points"<<endl;
	//output search space
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average search space (ss) for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:10 with points"<<endl;
	//output time spread
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_sp_t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time spread for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:51 with points"<<endl;
	//output ss spread
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_sp_ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"search space spread for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:52 with points"<<endl;
	//output time varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_t_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"time varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:53 with points"<<endl;
	//output choice varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_c_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"choice points varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:54 with points"<<endl;
	//output choice-wchoice varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_dc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"((choice points)-(wrong choice)) varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:64 with points"<<endl;
	//output search space varianz
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_ss_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"search space varianz for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:56 with points"<<endl;
	//output choice/time quotient
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_CdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"coice points time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"choice points/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:59 with points"<<endl;
	//output choice/time quotient variance
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_CdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"varianz of coice points time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"coice points/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:60 with points"<<endl;
	//output wrong choice/time quotient
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_WCdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong coices time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:61 with points"<<endl;
	//output choice/time quotient variance
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_WCdT_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"varianz of wrong coices time quotient for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong coices/time 1/s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:62 with points"<<endl;
	//output wchoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_wc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average wrong choices for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:9 with points"<<endl;
	//output wchoice varianc
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_var_wc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"wrong choices variance for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:55 with points"<<endl;
	//output mNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_m_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ time) - (positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:65 with points"<<endl;
	//output dNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ time)/(positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:66 with points"<<endl;
	//output logDNTimePTime
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_log_ntpt_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ time)/log(positiv time) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:67 with points"<<endl;
	//output mNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_m_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ choice points)-(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:68 with points"<<endl;
	//output dNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ choice points)/(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:69 with points"<<endl;
	//output dNChoicePChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_log_ncpc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ choice points)/log(positiv choice points) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:70 with points"<<endl;
	//output mNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_m_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ wrong choices)-(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:71 with points"<<endl;
	//output dNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"(negativ wrong choices)/(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:72 with points"<<endl;
	//output dNWChoicePWChoice
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_d_log_nwcpwc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"log(negativ wrong choices)/log(positiv wrong choices) for testcases\""<<endl;
	(*stream)<<"set zlabel \"Faktor\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:73 with points"<<endl;
	//output vertices
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_v_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"vertices for testcases\""<<endl;
	(*stream)<<"set zlabel \"vertices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:74 with points"<<endl;
	//output edges
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_ed_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"edges for testcases\""<<endl;
	(*stream)<<"set zlabel \"edges\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:75 with points"<<endl;
	//output literals
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_l_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average literals for testcases\""<<endl;
	(*stream)<<"set zlabel \"literals\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:3 with points"<<endl;


	//key section
	//output examples pos neg
//	(*stream)<<"set key"<<endl;
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_epn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples positiv, negative and all for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:14 title \"positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:19 title \"negativ examles\" with points"<<endl;
	//output examples pos
//	(*stream)<<"set key"<<endl;
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_ep_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average examples positiv and all for testcases\""<<endl;
	(*stream)<<"set zlabel \"examples n\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:14 title \"positiv examles\" with points"<<endl;
	//output time pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_tpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:15 title \"time positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:20 title \"time negativ examles\" with points"<<endl;
	//output choice pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_cpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average choice points for positiv, negative and all examples for testcases \""<<endl;
	(*stream)<<"set zlabel \"choice points\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:16 title \"choice positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:21 title \"choice negativ examles\" with points"<<endl;
	//output wrong choice pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_wcpn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average wrong choices for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"wrong choices\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:17 title \"wrong choice positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:22 title \"wrong choice negativ examles\" with points"<<endl;
	//output search space pos neg
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_sspn_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average search space for positiv, negative and all examples for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:18 title \"search space positiv examles\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:23 title \"search space negativ examles\" with points"<<endl;
	//output 10 maximal time classes
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_mtc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"maximal time of 10 time classes for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:24 title \"minimal time\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:25 title \"maximal time in class 1\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:26 title \"maximal time in class 2\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:27 title \"maximal time in class 3\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:28 title \"maximal time in class 4\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:29 title \"maximal time in class 5\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:30 title \"maximal time in class 6\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:31 title \"maximal time in class 7\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:32 title \"maximal time in class 8\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:33 title \"maximal time in class 9\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:34 title \"maximal time in class 10\" with points"<<endl;
	//output 10 time classes
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_tc_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average time of 10 time classes for testcases\""<<endl;
	(*stream)<<"set zlabel \"time s\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:35 title \"time in class 1\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:36 title \"time in class 2\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:37 title \"time in class 3\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:38 title \"time in class 4\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:39 title \"time in class 5\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:40 title \"time in class 6\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:41 title \"time in class 7\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:42 title \"time in class 8\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:43 title \"time in class 9\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:44 title \"time in class 10\" with points"<<endl;
	//output search space max min
	(*stream)<<"set output \"./tabellen/erg"<<baseName<<"/AR_ssmm_"<<baseName<<".ps\""<<endl;
	(*stream)<<"set title \"average, minimal and maximal search space for testcases\""<<endl;
	(*stream)<<"set zlabel \"search space ss\""<<endl;
	(*stream)<<"splot \"./tmpG1.txt\" using 57:58:10 title \"average search space\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:49 title \"minimal search space\" with points";
	(*stream)<<",\"./tmpG1.txt\" using 57:58:50 title \"maximal search space\" with points"<<endl;

	system("gnuplot ./gnuplotTmp.txt");
	stream->close();
	delete stream;
}else
	{printf( "Problem opening the file\n" );}
}

void makeData(list<TDResult> rL,char* baseName)
/*outputs the data of the results in the list TDResult,
outputs it in a seperated folder, wher it saves the tabel with head in a
excel readebel form, colums seperated by ";", and a number of graphs
pre: the bool atoms say if the atoms chang, rules say if the rules change
	and D3 say if the data should printed in a 3 dimensional graph or not,
	base name ist the base name of the folder and filse to store the data
	to (folders begins with "erg" and the baseName )
post: the data of the result list in a own folder*/
{
if (rL.size()<5){return;}//if net enoght results are in the list cancel the output
rL.sort();
//create the directory to store the data to
char b[20];
sprintf(b,"mkdir ./tabellen/erg%s",baseName);
cout<<b<<endl;
system(b);
//output date in a excel redebel form, with colums seperated by ";"
char outf[50];
sprintf(outf,"./tabellen/erg%s/HSC%s.txt",baseName,baseName);
ofstream *stream=new ofstream(outf);
if( stream!= NULL )
{
	writeHead(stream);
	for(list<TDResult>::iterator itr=rL.begin();itr!=rL.end();itr++)
		{writeResult(stream,(*itr));}
	stream->close();
	delete stream;
}else
	{printf( "Problem opening the file\n" );}
//output the data for gnuplot in a file
stream=new ofstream("./tmpG1.txt");
if( stream!= NULL )
{
	for(list<TDResult>::iterator itr=rL.begin();itr!=rL.end();itr++)
		{writeResultBl(stream,(*itr));}
	stream->close();
	delete stream;
}else
	{printf( "Problem opening the file\n" );}
//output date in a excel redebel form, with colums seperated by ";"
char outfg[50];
sprintf(outfg,"./tabellen/erg%s/HSGrC%s.txt",baseName,baseName);
stream=new ofstream(outfg);
if( stream!= NULL )
{
	for(list<TDResult>::iterator itr=rL.begin();itr!=rL.end();itr++)
		{writeResultBl(stream,(*itr));}
	stream->close();
	delete stream;
}else
	{printf( "Problem opening the file\n" );}

}



